## mosquitto-auth-plugin 0.0.7

=== Makefile ===
# Load our module (and misc) configuration from config.mk
# It also contains MOSQUITTO_SRC
include config.mk

BE_CFLAGS =
BE_LDFLAGS =
BE_LDADD =
BE_DEPS =
OBJS = auth-plug.o base64.o pbkdf2-check.o log.o envs.o hash.o be-psk.o backends.o cache.o

BACKENDS =
BACKENDSTR =

ifneq ($(BACKEND_CDB),no)
	BACKENDS += -DBE_CDB
	BACKENDSTR += CDB

	CDBDIR = contrib/tinycdb-0.78
	CDB = $(CDBDIR)/cdb
	CDBINC = $(CDBDIR)/
	CDBLIB = $(CDBDIR)/libcdb.a
	BE_CFLAGS += -I$(CDBINC)/
	BE_LDFLAGS += -L$(CDBDIR)
	BE_LDADD += -lcdb
	BE_DEPS += $(CDBLIB)
	OBJS += be-cdb.o
endif

ifneq ($(BACKEND_MYSQL),no)
	BACKENDS += -DBE_MYSQL
	BACKENDSTR += MySQL

	BE_CFLAGS += `mysql_config --cflags`
	BE_LDADD += `mysql_config --libs`
	OBJS += be-mysql.o
endif

ifneq ($(BACKEND_SQLITE),no)
	BACKENDS += -DBE_SQLITE
	BACKENDSTR += SQLite

	BE_LDADD += -lsqlite3
	OBJS += be-sqlite.o
endif

ifneq ($(BACKEND_REDIS),no)
	BACKENDS += -DBE_REDIS
	BACKENDSTR += Redis

	BE_CFLAGS += -I/usr/local/include/hiredis
	BE_LDFLAGS += -L/usr/local/lib
	BE_LDADD += -lhiredis
	OBJS += be-redis.o
endif

ifneq ($(BACKEND_POSTGRES),no)
	BACKENDS += -DBE_POSTGRES
	BACKENDSTR += PostgreSQL

	BE_CFLAGS += -I`pg_config --includedir`
	BE_LDADD += -L`pg_config --libdir` -lpq
	OBJS += be-postgres.o
endif

ifneq ($(BACKEND_LDAP),no)
	BACKENDS += -DBE_LDAP
	BACKENDSTR += LDAP

	BE_LDADD += -lldap -llber
	OBJS += be-ldap.o
endif

ifneq ($(BACKEND_HTTP), no)
	BACKENDS+= -DBE_HTTP
	BACKENDSTR += HTTP

	BE_LDADD += -lcurl
	OBJS += be-http.o
endif

ifneq ($(BACKEND_MONGO), no)
	BACKENDS+= -DBE_MONGO
	BACKENDSTR += MongoDB

	BE_CFLAGS += -I/usr/local/include/
	BE_LDFLAGS += -L/usr/local/lib
	BE_LDADD += -lmongoc-1.0 -lbson-1.0
	OBJS += be-mongo.o
endif

OSSLINC = -I$(OPENSSLDIR)/include
OSSLIBS = -L$(OPENSSLDIR)/lib -lcrypto

CFLAGS = -I$(MOSQUITTO_SRC)/src/
CFLAGS += -I$(MOSQUITTO_SRC)/lib/
ifneq ($(OS),Windows_NT)
	CFLAGS += -fPIC -Wall -Werror
endif
CFLAGS += $(BACKENDS) $(BE_CFLAGS) -I$(MOSQ)/src -DDEBUG=1 $(OSSLINC)
LDFLAGS = $(BE_LDFLAGS) -L$(MOSQUITTO_SRC)/lib/
# LDFLAGS += -Wl,-rpath,$(../../../../pubgit/MQTT/mosquitto/lib) -lc
# LDFLAGS += -export-dynamic
LDADD = $(BE_LDADD) $(OSSLIBS) -lmosquitto

all: printconfig auth-plug.so np

printconfig:
	@echo "Selected backends:         $(BACKENDSTR)"
	@echo "Using mosquitto source dir: $(MOSQUITTO_SRC)"
	@echo "OpenSSL install dir:        $(OPENSSLDIR)"
	@echo
	@echo "If you changed the backend selection, you might need to 'make clean' first"
	@echo
	@echo "CFLAGS:  $(CFLAGS)"
	@echo "LDFLAGS: $(LDFLAGS)"
	@echo "LDADD:   $(LDADD)"
	@echo



auth-plug.so : $(OBJS) $(BE_DEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) -fPIC -shared -o $@ $(OBJS) $(BE_DEPS) $(LDADD)

be-redis.o: be-redis.c be-redis.h log.h hash.h envs.h Makefile
be-sqlite.o: be-sqlite.c be-sqlite.h Makefile
auth-plug.o: auth-plug.c be-cdb.h be-mysql.h be-sqlite.h Makefile cache.h
be-psk.o: be-psk.c be-psk.h Makefile
be-cdb.o: be-cdb.c be-cdb.h Makefile
be-mysql.o: be-mysql.c be-mysql.h Makefile
be-ldap.o: be-ldap.c be-ldap.h Makefile
be-sqlite.o: be-sqlite.c be-sqlite.h Makefile
pbkdf2-check.o: pbkdf2-check.c base64.h Makefile
base64.o: base64.c base64.h Makefile
log.o: log.c log.h Makefile
envs.o: envs.c envs.h Makefile
hash.o: hash.c hash.h uthash.h Makefile
be-postgres.o: be-postgres.c be-postgres.h Makefile
cache.o: cache.c cache.h uthash.h Makefile
be-http.o: be-http.c be-http.h Makefile backends.h
be-mongo.o: be-mongo.c be-mongo.h Makefile

np: np.c base64.o
	$(CC) $(CFLAGS) $^ -o $@ $(OSSLIBS)

$(CDBLIB):
	(cd $(CDBDIR); make libcdb.a cdb )

pwdb.cdb: pwdb.in
	$(CDB) -c -m  pwdb.cdb pwdb.in
clean :
	rm -f *.o *.so np
	(cd contrib/tinycdb-0.78; make realclean )

config.mk:
	@echo "Please create your own config.mk file"
	@echo "You can use config.mk.in as base"
	@false

=== tinycdb-0.78/Makefile ===
#! /usr/bin/make -rf
# Makefile: make file for tinycdb package
#
# This file is a part of tinycdb package by Michael Tokarev, mjt@corpit.ru.
# Public domain.

VERSION = 0.78

prefix=/usr/local
exec_prefix=$(prefix)
bindir=$(exec_prefix)/bin
libdir=$(exec_prefix)/lib
syslibdir=$(libdir)
sysconfdir=/etc
includedir=$(prefix)/include
mandir=$(prefix)/man
NSSCDB_DIR = $(sysconfdir)
DESTDIR=

CC = cc -fPIC
CFLAGS = -O
CDEFS = -D_FILE_OFFSET_BITS=64
LD = $(CC)
LDFLAGS =

AR = ar
ARFLAGS = rv
RANLIB = ranlib

NSS_CDB = libnss_cdb.so.2
LIBBASE = libcdb
LIB = $(LIBBASE).a
PICLIB = $(LIBBASE)_pic.a
SHAREDLIB = $(LIBBASE).so.1
SOLIB = $(LIBBASE).so
CDB_USELIB = $(LIB)
NSS_USELIB = $(PICLIB)
LIBMAP = $(LIBBASE).map
INSTALLPROG = cdb

# The following assumes GNU CC/LD -
# used for building shared libraries only
CFLAGS_PIC = -fPIC
LDFLAGS_SHARED = -shared
LDFLAGS_SONAME = -Wl,--soname=
LDFLAGS_VSCRIPT = -Wl,--version-script=

CP = cp

LIB_SRCS = cdb_init.c cdb_find.c cdb_findnext.c cdb_seq.c cdb_seek.c \
 cdb_unpack.c \
 cdb_make_add.c cdb_make_put.c cdb_make.c cdb_hash.c
NSS_SRCS = nss_cdb.c nss_cdb-passwd.c nss_cdb-group.c nss_cdb-spwd.c
NSSMAP = nss_cdb.map

DISTFILES = Makefile cdb.h cdb_int.h $(LIB_SRCS) cdb.c \
 $(NSS_SRCS) nss_cdb.h nss_cdb-Makefile \
 cdb.3 cdb.1 cdb.5 \
 tinycdb.spec tests.sh tests.ok \
 $(LIBMAP) $(NSSMAP) \
 ChangeLog NEWS
DEBIANFILES = debian/control debian/rules debian/copyright debian/changelog

all: static
static: staticlib cdb
staticlib: $(LIB)
nss: $(NSS_CDB)
piclib: $(PICLIB)
sharedlib: $(SHAREDLIB)
shared: sharedlib cdb-shared

LIB_OBJS = $(LIB_SRCS:.c=.o)
LIB_OBJS_PIC = $(LIB_SRCS:.c=.lo)
NSS_OBJS = $(NSS_SRCS:.c=.lo)

$(LIB): $(LIB_OBJS)
	-rm -f $@
	$(AR) $(ARFLAGS) $@ $(LIB_OBJS)
	-$(RANLIB) $@

$(PICLIB): $(LIB_OBJS_PIC)
	-rm -f $@
	$(AR) $(ARFLAGS) $@ $(LIB_OBJS_PIC)
	-$(RANLIB) $@

$(SHAREDLIB): $(LIB_OBJS_PIC) $(LIBMAP)
	-rm -f $(SOLIB)
	ln -s $@ $(SOLIB)
	$(LD) $(LDFLAGS) $(LDFLAGS_SHARED) -o $@ \
	 $(LDFLAGS_SONAME)$(SHAREDLIB) $(LDFLAGS_VSCRIPT)$(LIBMAP) \
	 $(LIB_OBJS_PIC)

cdb: cdb.o $(CDB_USELIB)
	$(LD) $(LDFLAGS) -o $@ cdb.o $(CDB_USELIB)
cdb-shared: cdb.o $(SHAREDLIB)
	$(LD) $(LDFLAGS) -o $@ cdb.o $(SHAREDLIB)

$(NSS_CDB): $(NSS_OBJS) $(NSS_USELIB) $(NSSMAP)
	$(LD) $(LDFLAGS) $(LDFLAGS_SHARED) -o $@ \
	 $(LDFLAGS_SONAME)$@ $(LDFLAGS_VSCRIPT)$(NSSMAP) \
	 $(NSS_OBJS) $(NSS_USELIB)

.SUFFIXES:
.SUFFIXES: .c .o .lo

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -c $<
.c.lo:
	$(CC) $(CFLAGS) $(CDEFS) $(CFLAGS_PIC) -c -o $@ -DNSSCDB_DIR=\"$(NSSCDB_DIR)\" $<

cdb.o: cdb.h
$(LIB_OBJS) $(LIB_OBJS_PIC): cdb_int.h cdb.h
$(NSS_OBJS): nss_cdb.h cdb.h

clean:
	-rm -f *.o *.lo core *~ tests.out tests-shared.ok
realclean distclean:
	-rm -f *.o *.lo core *~ $(LIBBASE)[._][aps]* $(NSS_CDB)* cdb cdb-shared

test tests check: cdb
	sh ./tests.sh ./cdb > tests.out 2>&1
	diff tests.ok tests.out
	@echo All tests passed
test-shared tests-shared check-shared: cdb-shared
	sed 's/^cdb: /cdb-shared: /' <tests.ok >tests-shared.ok
	LD_LIBRARY_PATH=. sh ./tests.sh ./cdb-shared > tests.out 2>&1
	diff tests-shared.ok tests.out
	rm -f tests-shared.ok
	@echo All tests passed

do_install = \
 while [ "$$1" ] ; do \
   if [ .$$4 = .- ]; then f=$$1; else f=$$4; fi; \
   d=$(DESTDIR)$$3 ; echo installing $$1 to $$d/$$f; \
   [ -d $$d ] || mkdir -p $$d || exit 1 ; \
   $(CP) $$1 $$d/$$f || exit 1; \
   chmod 0$$2 $$d/$$f || exit 1; \
   shift 4; \
 done

install-all: all $(INSTALLPROG)
	set -- \
	 cdb.h 644 $(includedir) - \
	 cdb.3 644 $(mandir)/man3 - \
	 cdb.1 644 $(mandir)/man1 - \
	 cdb.5 644 $(mandir)/man5 - \
	 $(INSTALLPROG) 755 $(bindir) cdb \
	 libcdb.a 644 $(libdir) - \
	 ; \
	$(do_install)
install-nss: nss
	@set -- $(NSS_CDB) 644 $(syslibdir) - \
	        nss_cdb-Makefile 644 $(sysconfdir) cdb-Makefile ; \
	$(do_install)
install-sharedlib: sharedlib
	@set -- $(SHAREDLIB) 644 $(libdir) - ; \
	$(do_install) ; \
	ln -sf $(SHAREDLIB) $(DESTDIR)$(libdir)/$(LIBBASE).so
install-piclib: piclib
	@set -- $(PICLIB) 644 $(libdir) - ; \
	$(do_install)
install: install-all

DNAME = tinycdb-$(VERSION)
dist: $(DNAME).tar.gz
$(DNAME).tar.gz: $(DISTFILES) $(DEBIANFILES)
	mkdir $(DNAME) $(DNAME)/debian
	ln $(DISTFILES) $(DNAME)/
	ln $(DEBIANFILES) $(DNAME)/debian/
	tar cfz $@ $(DNAME)
	rm -fr $(DNAME)

.PHONY: all clean realclean dist spec
.PHONY: test tests check test-shared tests-shared check-shared
.PHONY: static staticlib shared sharedlib nss piclib
.PHONY: install install-all install-sharedlib install-piclib install-nss

=== debian/changelog ===
mosquitto-auth-plugin (0.0.7-2.1ubuntu3) bionic; urgency=medium

  * Reapply the openssl1.1 patch.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 09 Feb 2018 23:03:34 -0800

mosquitto-auth-plugin (0.0.7-2.1ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 17:54:36 +0000

mosquitto-auth-plugin (0.0.7-2.1ubuntu1) zesty; urgency=medium

  * Dont apply openssl 1.1 patch as openssl isnt present in ubuntu as 
    yet.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Mon, 13 Feb 2017 11:28:33 +0530

mosquitto-auth-plugin (0.0.7-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with OpenSSL 1.1.  (Closes: #828443)
  * Switch Build-Depends to default-libmysqlclient-dev.  (Closes: #845875)
  * Fix debian/rules clean.
  * Use canonical Vcs-* URLs.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 21 Jan 2017 18:38:50 +0100

mosquitto-auth-plugin (0.0.7-2) unstable; urgency=medium

  * Fix git paths in debian/control
  * Add missing build depends

 -- Adam Majer <adamm@zombino.com>  Wed, 20 Jan 2016 23:05:27 -0600

mosquitto-auth-plugin (0.0.7-1) unstable; urgency=low

  * Initial release (closes: #809986)

 -- Adam Majer <adamm@zombino.com>  Sat, 02 Jan 2016 20:04:53 -0600

=== debian/control ===
Source: mosquitto-auth-plugin
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Adam Majer <adamm@zombino.com>
Build-Depends: debhelper (>= 9), libssl-dev, libmosquitto-dev, mosquitto-dev,
               libhiredis-dev, default-libmysqlclient-dev, libpq-dev, libsqlite3-dev,
               libldap2-dev, libcdb-dev, libcurl4-gnutls-dev
Standards-Version: 3.9.6
Homepage: https://github.com/jpmens/mosquitto-auth-plug
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mosquitto-auth-plugin.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mosquitto-auth-plugin.git

Package: mosquitto-auth-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Authentication plugin for Mosquitto with multiple back-ends
 Authentication plugin for Mosquitto with multiple backends for
 MySQL, PostgreSQL, Redis, CDB, SQLite3 and LDAP

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ 

override_dh_auto_build:
	VPATH=.. $(MAKE) -C build

override_dh_auto_install:
	dh_auto_install
	cp build/auth-plug.so debian/mosquitto-auth-plugin/usr/lib/mosquitto-auth-plugin/auth-plugin.so
	cp build/np           debian/mosquitto-auth-plugin/usr/bin/

override_dh_auto_configure:
	mkdir -p build
	cp -l Makefile config.mk build

override_dh_auto_clean:
	rm -rf build

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/mosquitto-auth-plugin-$1.tar.gz/" \
         https://github.com/jpmens/mosquitto-auth-plug/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## mosquitto-auth-plugin 0.1.2

=== Makefile ===
--- 
+++ 
@@ -78,26 +78,46 @@
 	OBJS += be-http.o
 endif
 
+ifneq ($(BACKEND_JWT), no)
+	BACKENDS+= -DBE_JWT
+	BACKENDSTR += JWT
+
+	BE_LDADD += -lcurl
+	OBJS += be-jwt.o
+endif
+
 ifneq ($(BACKEND_MONGO), no)
 	BACKENDS+= -DBE_MONGO
 	BACKENDSTR += MongoDB
 
 	BE_CFLAGS += -I/usr/local/include/
+	BE_CFLAGS += -I/usr/local/include/libmongoc-1.0/
+	BE_CFLAGS += -I/usr/local/include/libbson-1.0/
 	BE_LDFLAGS += -L/usr/local/lib
 	BE_LDADD += -lmongoc-1.0 -lbson-1.0
 	OBJS += be-mongo.o
 endif
 
+ifneq ($(BACKEND_FILES), no)
+	BACKENDS+= -DBE_FILES
+	BACKENDSTR += Files
+
+	OBJS += be-files.o
+endif
+
 OSSLINC = -I$(OPENSSLDIR)/include
 OSSLIBS = -L$(OPENSSLDIR)/lib -lcrypto
 
-CFLAGS = -I$(MOSQUITTO_SRC)/src/
+CFLAGS := $(CFG_CFLAGS)
+CFLAGS += -I$(MOSQUITTO_SRC)/src/
 CFLAGS += -I$(MOSQUITTO_SRC)/lib/
 ifneq ($(OS),Windows_NT)
 	CFLAGS += -fPIC -Wall -Werror
 endif
 CFLAGS += $(BACKENDS) $(BE_CFLAGS) -I$(MOSQ)/src -DDEBUG=1 $(OSSLINC)
-LDFLAGS = $(BE_LDFLAGS) -L$(MOSQUITTO_SRC)/lib/
+
+LDFLAGS := $(CFG_LDFLAGS)
+LDFLAGS += $(BE_LDFLAGS) -L$(MOSQUITTO_SRC)/lib/
 # LDFLAGS += -Wl,-rpath,$(../../../../pubgit/MQTT/mosquitto/lib) -lc
 # LDFLAGS += -export-dynamic
 LDADD = $(BE_LDADD) $(OSSLIBS) -lmosquitto
@@ -137,10 +157,12 @@
 be-postgres.o: be-postgres.c be-postgres.h Makefile
 cache.o: cache.c cache.h uthash.h Makefile
 be-http.o: be-http.c be-http.h Makefile backends.h
+be-jwt.o: be-jwt.c be-jwt.h Makefile backends.h
 be-mongo.o: be-mongo.c be-mongo.h Makefile
+be-files.o: be-files.c be-files.h Makefile
 
 np: np.c base64.o
-	$(CC) $(CFLAGS) $^ -o $@ $(OSSLIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@ $(OSSLIBS)
 
 $(CDBLIB):
 	(cd $(CDBDIR); make libcdb.a cdb )

=== debian/changelog ===
mosquitto-auth-plugin (0.1.2-1build1) disco; urgency=medium

  * No-change rebuild against libhiredis0.14

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 12 Nov 2018 08:47:35 +0000

mosquitto-auth-plugin (0.1.2-1) unstable; urgency=medium

  * New upstream version
  * debian/control:
    + update build-depends
    + updated Standards to 4.0.0
  * debian/patches:
    + fix_np_getopt: removed, upstreamed
    + fix_makefile: ported to new version

 -- Adam Majer <adamm@zombino.com>  Sun, 20 Aug 2017 01:00:47 -0500

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends: debhelper (>= 9), libssl-dev, libmosquitto-dev, mosquitto-dev,
                libhiredis-dev, default-libmysqlclient-dev, libpq-dev, libsqlite3-dev,
                libldap2-dev, libcdb-dev, libcurl4-gnutls-dev
-Standards-Version: 3.9.6
+Standards-Version: 4.0.0
 Homepage: https://github.com/jpmens/mosquitto-auth-plug
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/mosquitto-auth-plugin.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mosquitto-auth-plugin.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/mosquitto-auth-plugin.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mosquitto-auth-plugin.git;a=summary
 
 Package: mosquitto-auth-plugin
 Architecture: any
